package com.vitorflores.connectfit.Adapter;

import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.vitorflores.connectfit.LookUpExerciseActivity;
import com.vitorflores.connectfit.LookUpWorkoutActivity;
import com.vitorflores.connectfit.Model.Exercise;
import com.vitorflores.connectfit.Model.Workout;
import com.vitorflores.connectfit.R;

import java.util.List;

public class WorkoutAdapter extends RecyclerView.Adapter<WorkoutAdapter.ViewHolder> {

    private Context mContext;
    private List<Workout> mWorkouts;

    public WorkoutAdapter(Context mContext, List<Workout> mWorkouts) {
        this.mContext = mContext;
        this.mWorkouts = mWorkouts;
    }

    @NonNull
    @Override
    public WorkoutAdapter.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(mContext).inflate(R.layout.item_workout, parent, false);
        return new WorkoutAdapter.ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull WorkoutAdapter.ViewHolder holder, int position) {
        final Workout workout = mWorkouts.get(position);

        holder.name.setText(workout.getName());
        Log.d("teste", "Status: " + workout.getIsPending());
        if (workout.getIsPending()) {
            holder.status.setText("Pendente");
        } else {
            holder.status.setText("Concluído");
        }
        holder.date.setText(workout.getDate());
        holder.itemView.setOnClickListener(view -> {

            Intent intent = new Intent(mContext, LookUpWorkoutActivity.class);
            intent.putExtra("name", mWorkouts.get(position).getName());
            intent.putExtra("proId", mWorkouts.get(position).getProId());
            intent.putExtra("clientId", mWorkouts.get(position).getClientId());
            intent.putExtra("id", mWorkouts.get(position).getId());
            mContext.startActivity(intent);
        });
    }

    @Override
    public int getItemCount() {
        return mWorkouts.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        public TextView name, status, date;

        public ViewHolder(View itemView) {
            super(itemView);

            name = itemView.findViewById(R.id.textWorkoutName);
            status = itemView.findViewById(R.id.textStatus);
            date = itemView.findViewById(R.id.textDate);
        }
    }
}
