package com.vitorflores.connectfit;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.vitorflores.connectfit.Client.AccountClientSettingsActivity;

public class ResetPasswordActivity extends AppCompatActivity {

    // Visual elements
    private Button mBtnResetPassword;
    private EditText mFieldEmail;

    // Firebase Authentication
    FirebaseAuth mFirebaseAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reset_password);

        // Toolbar
        Toolbar toolbar = findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setTitle(R.string.bar_title_reset_password);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        toolbar.setNavigationOnClickListener(view -> finish());

        // Visual elements
        mBtnResetPassword = findViewById(R.id.btnResetPassword);
        mFieldEmail = findViewById(R.id.fieldEmail);

        // Firebase auth
        mFirebaseAuth = FirebaseAuth.getInstance();

        mBtnResetPassword.setOnClickListener(view -> {
            String email = mFieldEmail.getText().toString().toLowerCase();

            if (email.equals("")) {
                Toast.makeText(ResetPasswordActivity.this, R.string.system_message_empty_fields, Toast.LENGTH_SHORT).show();
            } else {
                mFirebaseAuth.sendPasswordResetEmail(email).addOnCompleteListener(task -> {
                    if (task.isSuccessful()) {
                        Toast.makeText(ResetPasswordActivity.this, R.string.system_message_check_your_email, Toast.LENGTH_SHORT).show();
                        startActivity(new Intent(ResetPasswordActivity.this, LoginUserActivity.class));
                    } else {
                        String error = task.getException().getMessage();
                        Toast.makeText(ResetPasswordActivity.this, email, Toast.LENGTH_SHORT).show();
                    }
                });
            }
        });
    }
}